#include "trans.h"

#define PADDING '='

unsigned char b64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" \
                      "abcdefghijklmnopqrstuvwxyz" \
                      "0123456789" \
                      "+/";

unsigned char *
encode(unsigned char *op, int np)
{
    extern unsigned char s[];
    unsigned char *sp;
    int n;

    sp = s;
    switch (np) {
        case 3:
            *sp++ = b64[(*op & ~3) >> 2];
            n = (*op++ & 3) << 4;
            *sp++ = b64[n + ((*op & ~15) >> 4)];
            n = (*op++ & 15) << 2;
            *sp++ = b64[n + ((*op & 192) >> 6)];
            *sp = b64[*op & ~192];
            break;
        case 2:
            *sp++ = b64[(*op & ~3) >> 2];
            n = (*op++ & 3) << 4;
            *sp++ = b64[n + ((*op & ~15) >> 4)];
            *sp++ = b64[(*op & 15) << 2];
            *sp = PADDING;
            break;
        case 1:
            *sp++ = b64[(*op & ~3) >> 2];
            *sp++ = b64[(*op & 3) << 4];
            *sp++ = PADDING;
            *sp = PADDING;
            break;
    }

    return s;
}

unsigned char *
decode(unsigned char *sp, int *np)
{
    extern unsigned char o[];
    unsigned char *op;
    int n, b, atob(int c);

    op = o;
    switch (*np) {
        case 4:
            n = atob(*sp++) << 2;
            b = atob(*sp++);
            *op++ = n + ((b & ~15) >> 4);

            n = (b & 15) << 4;
            b = atob(*sp++);
            *op++ = n + ((b & ~3) >> 2);

            *op = ((b & 3) << 6) + atob(*sp);
            break;
        case 3:
            n = atob(*sp++) << 2;
            b = atob(*sp++);
            *op++ = n + ((b & ~15) >> 4);

            n = (b & 15) << 4;
            *op = n + ((atob(*sp) & ~3) >> 2);
            break;
        case 2:
            n = atob(*sp++) << 2;
            *op = n + ((atob(*sp) & ~15) >> 4);
            break;
    }
    *np = op-o+1;

    return o;
}

int atob(int c)
{
    if (c >= 'A' && c <= 'Z')
        c -= 'A';
    else if (c >= 'a' && c <= 'z')
        c = c - 'a' + 26;
    else if (c >= '0' && c <= '9')
        c = c - '0' + 26 * 2;
    else if (c == '+')
        c = 62;
    else
        c = 63;

    return c;
}
